// Electronic signature functions

// 

#include "types.h"
//#include <math.h>
//#include <stdio.h>
#include "random.h"
#include "signature.h"
#include "inverse.h"
#include "simple_test.h"
#include "serialize.h"
#include "hash_func.h"
#include "random.h"
#include "xex_mode.h"
#include "primes.h"
#include "pkf.h"
#include <string.h>
#include "system_critical_section.h"


/*
// m = hashed message

static u32 p = 23; // safe prime
static u32 q = 11; // (p-1)/2, also prime
static u32 g = 2;  // (g^q) mod p == 1 ;   g = (h^2) mod P, h - random number, but g > 1;  
static u32 g_ = 12; // inverse of g modulo p 

static u32 k = 10;  // any random number less then q
static u32 x = 8;  // secret key, less then q
static u32 y = 7;  // open key = (g^x) mod q
static u32 m = 22; // hash 
static u32 r = 19; // r = ((mg)^k) mod p
static u32 r_ = 8; // r_ = r mod q
static u32 s = 8;  // (k - r_ x) mod q

//------

static u32 mm = 0; // ((g^s)(y^r_)r) mod p  256 x 12 x 19 

//---------
static u32 upow(u32 x, u32 y, u32 p)
{
u32 result = 1;
    
for(u32 ci = 0; ci < y; ci++)
 {
 result = (result * x) % p;
 }

return result;
}
*/
//------------------------
// find inverse of g modulo p
//
// (g g_) mod p = 1
// i.e. g g_ = k p + 1
//
// k p - g g_ = 1
//
// Euclidean algorithm
//
/*
void test_euclid(s32 a, s32 b)
{
s32 x0 = 1;
s32 y0 = 0;

s32 x1 = 0;
s32 y1 = 1;

s32 r0 = x0*a + y0*b;
s32 r1 = x1*a + y1*b;
 
//-- loop --

  for(;;)
   { 
   s32 qi = r0/r1;
   s32 ri = r0 - qi*r1; // remainder
   
   printf("\n qi = %d ri = %d", qi, ri);
   
   if(!ri) 
    { 
    printf("\n Test x = %d y = %d", x1, y1);
    break;
    }
   
  


   s32 xi = x0 - qi*x1;
   s32 yi = y0 - qi*y1;
  
   //if(xi < 0) xi += b;
   
   //if(yi < 0) yi += a;
   
 
   y0 = y1;
   y1 = yi;
   x0 = x1;
   x1 = xi;
   r0 = r1;
   r1 = ri;
   }
}
*/
/*
void test_euclid(s32 a, s32 b)
{
s32 x1 = 0;
s32 y1 = 1;

s32 x2 = 1;
s32 y2 = 0;

s32 q, r, x, y;

while(b > 0)
 {
 q = a/b;
 r = a - q*b;
 x = x2 - q*x1;
 y = y2 - q*y1;
 a = b;
 b = r;
 x2 = x1;
 x1 = x;
 y2 = y1;
 y1 = y;
 }

printf("\n x = %d y = %d", x2, y2); 
}


//-------------------
// g = x^2 mod p; g > 1
// x = random number
// 
static void test_generate_g()
{
u32 foo;

for(u32 ci = 2; ci <= 65535; ci++)
 {
 g = (ci*ci)%p; // square(h) modulo P

 if(g <= 1) continue; // must be > 1
 
 // check 

 if(upow(g, q, p) != 1)
  {
  printf("\n Foo: g = %u", g);
  }

 }

}


void test_sign(void)
{
test_euclid(120, 23);

test_generate_g();    

y = upow(g, x, p);
r = (upow(g_, k, p) * m) % p; 
r_ = r % q;

u32 r_x = (r_ * x) % q;
if(r_x > k) k += q;

s = (k - r_x) % q;

// check

u32 mm = (upow(g,s,p)*upow(y, r_, p)*r) % p;

printf("\n mm = %u", mm);
}
*/

static PKF g_pkf; // can not assign to any of classes
static SYSTEM_CRITICAL_SECTION pkf_critical_section; // must be static

//---------------

DIGITAL_SIGNATURE::DIGITAL_SIGNATURE(u32 length_x32)
{
len = length_x32;
g_  = new u32[len];    
k   = new u32[len];
q   = new u32[len];
r_  = new u32[len];   
tmp = new u32[2*len];
tmp1 = new u32[2*len];
tmp2 = new u32[2*len];
tmp_prod = new u32[2*len];

tmp_u8_len = sizeof(SERTIFICATE);
tmp_u8 = new u8[tmp_u8_len]; // must be big enough to fit certificate

fmpm = new MONTGOMERY_POW_MOD(len); 
multi_div = new MULTI_DIV(len);
im = new INVERSE_MODULO(len);
tgmp = new TEST_GENERATOR_MODULO_P(len);
dh_hash = new DH_HASH;

inverse_g_is_precalculated = 0;
zero(precalculated_certificate_fingerprint,fingerprint_length_x32);
}

DIGITAL_SIGNATURE::~DIGITAL_SIGNATURE()
{
DIGITAL_SIGNATURE::reset();
delete dh_hash;    
delete tgmp;    
delete im;
delete multi_div;    
delete fmpm;
delete[] tmp_u8;
delete[] tmp_prod;
delete[] tmp2;
delete[] tmp1;
delete[] tmp;
delete[] r_;    
delete[] q;
delete[] k;
delete[] g_;
}

void DIGITAL_SIGNATURE::reset()
{
//cheap_random_number(g_,len); // Do not reset, g_ could be reused
//

cheap_random_number(q,len);
cheap_random_number(k,len);
cheap_random_number(r_,len);
cheap_random_number(tmp,2*len);
cheap_random_number(tmp1,2*len);
cheap_random_number(tmp2,2*len);
cheap_random_number(tmp_prod,2*len);
cheap_random_number(tmp_u8,tmp_u8_len);

fmpm->reset();
multi_div->reset();
im->reset();
tgmp->reset();
dh_hash->reset();
reset_stack();
}


//------------------------------------------------------------------
// This decodes data from signature using certificate
//
void DIGITAL_SIGNATURE::decode_signature(u32 *data, SIGNATURE const* ds, SERTIFICATE const* sert)
{
//
// q = (p-1)/2    
//
copy(q, sert->p, len);
multi_shift_right(q, len);

//
// r_ = r mod q
// 
multi_div->multi_div(tmp, r_, ds->r, q);

//
// tmp = (g ^ s) mod p
//    
fmpm->multi_pow_mod(tmp, sert->g, ds->s, sert->p);   

//
// tmp1 = (y ^ r_) mod p
//
fmpm->multi_pow_mod(tmp1, sert->y, r_, sert->p);

//
// tmp = (tmp x tmp1) mod p
//
multi_mul(tmp_prod, tmp, tmp1, len);
fmpm->fm->fast_modulo(tmp, tmp_prod);

//
// signature = (tmp x r) mod p
//
multi_mul(tmp_prod, tmp, ds->r, len);
fmpm->fm->fast_modulo(data, tmp_prod);
}
//--------------------------------------------------------------------------
// This encodes data into signature using certificate and signing secret key 
//
//
void DIGITAL_SIGNATURE::encode_signature(SIGNATURE *ds, u32 *data, SERTIFICATE const* sert, u32 const* secret_key)
{
//    
// Note: g_ could be precalculated
//

if((!inverse_g_is_precalculated) || (0 != multi_compare(sert->fingerprint,precalculated_certificate_fingerprint, fingerprint_length_x32)))
 {
 inverse_g_is_precalculated = 1;
 copy(precalculated_certificate_fingerprint, sert->fingerprint, fingerprint_length_x32);   

 //  
 // g_ = inverse g modulo p, i.e (g g_) mod p == 1
 // 
 im->inverse(g_, sert->g, sert->p);
 }

//
// q = (p-1)/2    
//
copy(q, sert->p, len);
multi_shift_right(q, len);
 

//
// Random temporary value k (k must be less then q)
//
random_number(k, len);
k[len-1] &= 0x3FFFFFFF; // ensure size 1 bit smaller then q
 

// 
// tmp = (g_ ^k) mod p
//
fmpm->multi_pow_mod(tmp, g_, k, sert->p);


//
// r = (tmp x data) mod p
//
data[len-1] &= 0x3FFFFFFF; // ensure size 1 bit smaller then q
multi_mul(tmp_prod, tmp, data, len);
fmpm->fm->fast_modulo(ds->r ,tmp_prod);


//
// r_ = r mod q
// 
multi_div->multi_div(tmp, r_, ds->r, q);


//
// tmp = (r_  x) mod q
// 
multi_mul(tmp_prod, r_, secret_key, len);

zero(tmp2, 2*len);
copy(tmp2, q, len);
::multi_div(tmp1, tmp, tmp_prod, tmp2, 2*len);

//
// if (r_ x) mod q  > k then k += q
//
if(multi_compare(tmp, k, len) > 0) multi_add(k, k, q, len);
 
//
//  s = (k - r_x) mod q
//
multi_sub(k, k, tmp, len);
multi_div->multi_div(tmp, ds->s, k, q);

// Cleanup

reset(); 

// Add fingerprint

copy(ds->fingerprint, sert->fingerprint, fingerprint_length_x32);
}


int DIGITAL_SIGNATURE::encode_signature(SIGNATURE *ds, u32 * data, SERTIFICATE const* sert, ENCODED_SECRET_KEY const *esc, u8 const *password, const u32 password_length_bytes)
{
u32 secret_key[signature_length_x32];    

int ret_value = 0;

if(decode_secret_key(secret_key, esc, password, password_length_bytes))
 {
 DIGITAL_SIGNATURE::encode_signature(ds, data, sert, secret_key);
 ret_value = 1;
 }

cheap_random_number(secret_key, signature_length_x32);

return ret_value;
}

int DIGITAL_SIGNATURE::encode_signature(SIGNATURE *ds, u32 * data, SECRET_DATA const *secret_data, u8 const *password, const u32 password_length_bytes)
{
return DIGITAL_SIGNATURE::encode_signature(ds, data, &secret_data->certificate, &secret_data->encoded_secret_key, password, password_length_bytes);
}

//---------------------------------------
// Generate certificate and secret signing key
//
void DIGITAL_SIGNATURE::generate_keys(SERTIFICATE * sert, u32 *secret_key, u32 const *p, u8 const *userinfo, u16 userinfo_length_bytes)
{

copy(sert->p, p, len);    

// Generate g = h^2 mod p
// h = random number 
// g must be >= 2    

do {    
   random_number(tmp, len); // h
   multi_mul(tmp_prod, tmp, tmp, len);          // h^2  
   zero(tmp2, 2*len);
   copy(tmp2, sert->p, len);
   ::multi_div(tmp1, tmp, tmp_prod, tmp2, 2*len);  // h^2 mod P 
   copy(sert->g, tmp, len);
   } while(less_then_two(sert->g, len)); // just for sanity


random_number(secret_key, len);
secret_key[len-1] &= 0x3FFFFFFF; // must be less then q

// 
// open key = (g^secret_key) mod p
//
fmpm->multi_pow_mod(sert->y, sert->g, secret_key, sert->p);

//
// Calculate fingerprint
//

calculate_fingerprint(sert->fingerprint, sert);

// cleanup

reset();

// Include user info

include_user_info(sert, userinfo, userinfo_length_bytes);
}

void DIGITAL_SIGNATURE::generate_keys(SECRET_DATA *secret_data, u8 const *password, u32 const password_length_bytes, 
                                      u8 const *userinfo, u16 userinfo_length_bytes)
{

u32 secret_key[signature_length_x32];
u32 p[signature_length_x32];

get_p(p);

DIGITAL_SIGNATURE::generate_keys(&secret_data->certificate, secret_key, p, userinfo, userinfo_length_bytes);

encode_secret_key(&secret_data->encoded_secret_key, secret_key, password, password_length_bytes);

cheap_random_number(secret_key, signature_length_x32);
cheap_random_number(p, signature_length_x32);
secret_data->data_is_initialized = 1;
}
  

void DIGITAL_SIGNATURE::include_user_info(SERTIFICATE * sert, u8 const *userinfo, u16 userinfo_length_bytes)
{
memset(sert->user_info, 0, user_info_max_length_bytes);   // must be zero 
sert->user_info_length_bytes = 0;
 
if((userinfo_length_bytes) && (userinfo != NULL))
 {
    
 if(userinfo_length_bytes > user_info_max_length_bytes) userinfo_length_bytes = user_info_max_length_bytes;
  
 memcpy(sert->user_info, userinfo, userinfo_length_bytes); 
 sert->user_info_length_bytes = userinfo_length_bytes;
 }
}


//--------------
void DIGITAL_SIGNATURE::calculate_fingerprint(u32 *fingerprint, SERTIFICATE const* sert) // 256-bit fingerprint u32[8]
{
// Compute hash ignoring fingerprint and userinfo fields

dh_hash->hash(fingerprint, sert->g, sert->y, sert->p); // 4096 bit values -> 256 bit hash
}
//---------------

u32 DIGITAL_SIGNATURE::serialize_certificate(u8 *bytes, SERTIFICATE const* sert)
{
u16_to_bytes(bytes, sert->user_info_length_bytes);
u32 offset = 2;

memcpy(bytes + offset, sert->user_info, user_info_max_length_bytes);
offset += user_info_max_length_bytes;

serialize_u32(bytes + offset, sert->fingerprint, fingerprint_length_x32);
offset += 4*fingerprint_length_x32;

serialize_u32(bytes + offset, sert->p, len);
offset += 4*len;

serialize_u32(bytes + offset, sert->g, len);
offset += 4*len;

serialize_u32(bytes + offset, sert->y, len);
offset += 4*len;

return offset;
}

u32 DIGITAL_SIGNATURE::deserialize_certificate(SERTIFICATE * sert, u8 const* bytes)
{
sert->user_info_length_bytes = bytes_to_u16(bytes);
u32 offset = 2;

memcpy(sert->user_info, bytes + offset, user_info_max_length_bytes);
offset += user_info_max_length_bytes;

deserialize_u32(sert->fingerprint, bytes + offset,  fingerprint_length_x32);
offset += 4*fingerprint_length_x32;

deserialize_u32(sert->p, bytes + offset, len);
offset += 4*len;

deserialize_u32(sert->g, bytes + offset, len);
offset += 4*len;

deserialize_u32(sert->y, bytes + offset, len);
offset += 4*len;


return offset;
}

u32 DIGITAL_SIGNATURE::serialize_signature(u8 *bytes, SIGNATURE const *sign) // returns length in bytes = 4*2*128 = 1024 bytes
{
serialize_u32(bytes, sign->fingerprint, fingerprint_length_x32);     
u32 offset = 4*fingerprint_length_x32;

serialize_u32(bytes + offset, sign->r, len);
offset += 4*len;

serialize_u32(bytes + offset, sign->s, len);
offset += 4*len;

return offset;
}

u32 DIGITAL_SIGNATURE::deserialize_signature(SIGNATURE *sign, u8 const *bytes) // returns length in bytes = 4*2*128 = 1024 bytes
{
deserialize_u32(sign->fingerprint, bytes, fingerprint_length_x32);
u32 offset = 4*fingerprint_length_x32;

deserialize_u32(sign->r, bytes + offset, len);
offset += 4*len;

deserialize_u32(sign->s, bytes + offset, len);
offset += 4*len;

return offset;
}
//
// Check if certificate looks valid 
// (before checking signature)
//
int DIGITAL_SIGNATURE::certificate_looks_ok(SERTIFICATE const* sert) // checks if fingerprint is matching certificate
{
u32 fingerprint[fingerprint_length_x32];

calculate_fingerprint(fingerprint, sert);

if(0 != multi_compare(fingerprint, sert->fingerprint,  fingerprint_length_x32)) return 0; // fingerprint must match    

// Check userinfo

if(sert->user_info_length_bytes > user_info_max_length_bytes) return 0;

for(u32 ci = sert->user_info_length_bytes; ci < user_info_max_length_bytes; ci++)
 {
 if(sert->user_info[ci] != 0) return 0;
 }

// check sizes

if(less_then_two(sert->g, len)) return 0; // g must be >= 2

if(multi_compare(sert->g, sert->p, len) >= 0) return 0; // g mist be < P

if(!(sert->p[len-1] & 0x80000000)) return 0; // P must be full size

if(0x03 != (sert->p[0] & 0x03)) return 0; // P must be safe prime, so two lsbs must be 0x03

if(0 != tgmp->test_generator_modulo_p(sert->g, sert->p)) return 0; // g must not be generator modulo P

return 1;
}




void SIGNATURE::reset()
{
cheap_random_number(fingerprint, fingerprint_length_x32);
cheap_random_number(r,signature_length_x32);
cheap_random_number(s,signature_length_x32);
reset_stack();
}

void SERTIFICATE::reset()
{
cheap_random_number(fingerprint,fingerprint_length_x32);
cheap_random_number(p,signature_length_x32);
cheap_random_number(g,signature_length_x32);
cheap_random_number(y,signature_length_x32);

user_info_length_bytes = user_info_max_length_bytes;
cheap_random_number(user_info, user_info_max_length_bytes);
reset_stack();
}

void compose_signature_data(u32 *data, u32 const *dh_hash, SERTIFICATE const* sert)
{
u32 offset = 0;    
zero(data, signature_length_x32);    
copy(data, dh_hash, 8);
offset += 8;

copy(data + offset, sert->fingerprint, fingerprint_length_x32);
offset += fingerprint_length_x32; 

for(u32 ci = 0; ci < (user_info_max_length_bytes/4); ci++)
 {
 data[offset] = bytes_to_u32(sert->user_info + 4*ci);
 offset++;
 }

data[signature_length_x32 - 1]  = ((u32)sert->user_info_length_bytes) << 16;
data[signature_length_x32 - 1] |= ((u32)sert->user_info[user_info_max_length_bytes-2]) << 8;
data[signature_length_x32 - 1] |= ((u32)sert->user_info[user_info_max_length_bytes-1]);
}

void decompose_signature_data(u32 *dh_hash,
                              u32 *fingerprint, 
                              u8 *userinfo,
                              u16 *userinfo_length_bytes,
                               u32 const* data)
{

u32 offset = 0;

copy(dh_hash, data, 8);
offset += 8;

copy(fingerprint, data + offset,  fingerprint_length_x32);
offset += fingerprint_length_x32; 

for(u32 ci = 0; ci < (user_info_max_length_bytes/4); ci++)
 {
 u32_to_bytes(userinfo + 4*ci, data[offset]);   
 offset++;
 }

*userinfo_length_bytes =  (u16)(data[signature_length_x32 - 1] >> 16);
userinfo[user_info_max_length_bytes-2] =  (u8)(data[signature_length_x32 - 1] >> 8);
userinfo[user_info_max_length_bytes-1] =  (u8)(data[signature_length_x32 - 1]);
}

//----------------------

void encode_secret_key(ENCODED_SECRET_KEY *esc, u32 const * secret_key, u8 const * password, const u32 password_length_bytes)
{
u32 key_cntr[10];

zero(key_cntr, 10);
Hash_Block_X_64(key_cntr, (u8 const *)secret_key, 4*signature_length_x32);
esc->hash = key_cntr[0] + key_cntr[1];

random_number(esc->salt,salt_length_x32);

pkf_critical_section.EnterCriticalSection();

g_pkf.get_key(key_cntr,sizeof(key_cntr),esc->salt,salt_length_x32*sizeof(u32),password,password_length_bytes);

pkf_critical_section.LeaveCriticalSection();


copy(esc->key, secret_key, signature_length_x32);
XEX_Encrypt_Block(esc->key, &key_cntr[8], key_cntr, signature_length_x32);

zero(key_cntr, 10); // cleanup
reset_stack();
}


int decode_secret_key(u32 * secret_key, ENCODED_SECRET_KEY const* esc, u8 const * password, const u32 password_length_bytes) // Returns nonzero on success
{
u32 key_cntr[10];

pkf_critical_section.EnterCriticalSection();

g_pkf.get_key(key_cntr,sizeof(key_cntr),esc->salt,salt_length_x32*sizeof(u32),password,password_length_bytes);

pkf_critical_section.LeaveCriticalSection();


copy(secret_key, esc->key, signature_length_x32);
XEX_Decrypt_Block(secret_key, &key_cntr[8], key_cntr, signature_length_x32);

zero(key_cntr, 10); // cleanup

Hash_Block_X_64(key_cntr, (u8 const *)secret_key, 4*signature_length_x32);
u32 hash = key_cntr[0] + key_cntr[1];

return (hash == esc->hash) ?  1 : 0;
}

int change_password(ENCODED_SECRET_KEY * esc, 
                    u8 const * old_password, const u32 old_password_length_bytes,
                    u8 const * new_password, const u32 new_password_length_bytes)
{
u32 key[signature_length_x32];

int ret_value = 0;

if(decode_secret_key(key, esc, old_password, old_password_length_bytes))
 {
 encode_secret_key(esc, key, new_password, new_password_length_bytes);
 ret_value = 1;
 }

cheap_random_number(key, signature_length_x32);
reset_stack();

return ret_value;
}

int check_password(ENCODED_SECRET_KEY const *esc, u8 const * password, const u32 password_length_bytes)
{
u32 key[signature_length_x32];

int ret_value = decode_secret_key(key, esc, password, password_length_bytes);

cheap_random_number(key, signature_length_x32);
reset_stack();

return ret_value;
}


void ENCODED_SECRET_KEY::reset()
{
cheap_random_number(key, signature_length_x32);
cheap_random_number(&hash, 1);
reset_stack();
}


//------------------------------------------
// Sign anything with full length signature
// Returns nonzero on success

int calculate_signature(SIGNATURE *signature, SECRET_DATA  const *secret_data,
           u8 const *password, u32 const password_length_bytes,
            void const *data, u32 const data_size_bytes)
{
DIGITAL_SIGNATURE ds;
COLLAPSE collapse(signature_length_x32);
u32 hash[signature_length_x32];

collapse.hash(hash, data, data_size_bytes);
hash[signature_length_x32-1] &= 0x3FFFFFFF; // truncate to 4094 bits

return ds.encode_signature(signature, hash, secret_data, password, password_length_bytes);
}


int verify_signature(SIGNATURE const *signature, SERTIFICATE  const *certificate,
                     void const *data, u32 const data_size_bytes)
{
DIGITAL_SIGNATURE ds;
COLLAPSE collapse(signature_length_x32);
u32 hash[signature_length_x32];
u32 decoded_hash[signature_length_x32];

if(!ds.certificate_looks_ok(certificate)) return VERIFY_SIGNATURE_BAD_SERTIFICATE;

if(memcmp(certificate->fingerprint, signature->fingerprint, sizeof(u32)*fingerprint_length_x32))
 return VERIFY_SIGNATURE_WRONG_SERTIFICATE;

collapse.hash(hash, data, data_size_bytes);
hash[signature_length_x32-1] &= 0x3FFFFFFF; // truncate to 4094 bits

ds.decode_signature(decoded_hash, signature, certificate);

return (memcmp(hash, decoded_hash, sizeof(u32)*signature_length_x32)) ?  VERIFY_SIGNATURE_DOES_NOT_MATCH : VERIFY_SIGNATURE_OK;
}


//========================= <END> =============================
